unit ClientForm;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, DbxDatasnap, DB, SqlExpr, ServerMethodsClientProxy,
  StdCtrls, DBClient, DSConnect, ExtCtrls, DBCtrls, Grids, DBGrids;

type
  TForm2 = class(TForm)
    SQLConnection1: TSQLConnection;
    Button1: TButton;
    Button2: TButton;
    DSProviderConnection1: TDSProviderConnection;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Button3: TButton;
    btnSave: TButton;
    btnLoad: TButton;
    btnUndoCurrent: TButton;
    btnUndolast: TButton;
    btnUndoAll: TButton;
    btnConnect: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure btnUndoAllClick(Sender: TObject);
    procedure btnUndolastClick(Sender: TObject);
    procedure btnUndoCurrentClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnSaveClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure ClientDataSet1ReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure ClientDataSet1BeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
  private
    { Private declarations }
    const
      BriefcaseFile = 'c:\briefcase.xml';
    var DS: TServerMethods1Client;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
uses
  DSHTTPLayer, RecError, DbxCompressionFilter,
  mmsystem;

{$R *.dfm}

procedure TForm2.btnConnectClick(Sender: TObject);
begin
  ClientDataSet1.Open // Connect
end;

procedure TForm2.btnLoadClick(Sender: TObject);
begin
  ClientDataSet1.LoadfromFile(BriefcaseFile);
end;

procedure TForm2.btnSaveClick(Sender: TObject);
begin
  ClientDataSet1.SaveToFile(BriefcaseFile);
end;

procedure TForm2.btnUndoAllClick(Sender: TObject);
begin
  ClientDataSet1.CancelUpdates // undo all
end;

procedure TForm2.btnUndoCurrentClick(Sender: TObject);
begin
  ClientDataSet1.RevertRecord // undo current
end;

procedure TForm2.btnUndolastClick(Sender: TObject);
begin
  ClientDataSet1.UndoLastChange(True) // Undo last
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  ShowMessage( DateTimeToStr( DS.ServerTime))
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  Str: String;
  i: Integer;
  Start: Cardinal;
begin
  Str := '1234567890';
  for i:=1 to 16 do Str := Str + Str;
  Start := timeGetTime;
  Str := DS.EchoString(Str);
  Caption := IntToStr(timeGetTime - Start);
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  SQLConnection1.Connected := True;
  ClientDataSet1.ApplyUpdates(-1);
//  ClientDataSet1.Refresh
end;

procedure TForm2.ClientDataSet1BeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  if ClientDataSet1.Active then
  begin
    ClientDataSet1.Last;
    OwnerData := ClientDataSet1.FieldByName('EMP_NO').AsString
  end
  else
    OwnerData := '';
end;

procedure TForm2.ClientDataSet1ReconcileError(DataSet: TCustomClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind; var Action: TReconcileAction);
begin
//  ShowMessage(E.Message);
  Action := HandleReconcileError(DAtaSet, UpdateKind, E)
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SQLConnection1.Connected := False;
  DS.Free
end;

procedure TForm2.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := not ((ClientDataSet1.Active) or (ClientDataSet1.ChangeCount > 0));
  if not Canclose then
    ShowMessage('still changes left in ClientDataset')
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  SQLConnection1.Connected := True; // to server...
  DS := TServerMethods1Client.Create(
    SQLConnection1.DBXConnection);
end;

end.
